/*
 * A filesystem directory resource.
 *
 * Copyright (C) 2018, 2019, 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <ext2fs/ext2fs.h>

#include <fsserver/file_resource.h>



/* Filesystem directory resource. */

class Fs_directory : public MappedFileResource
{
private:
  ext2_filsys _fs;
  ext2_ino_t _dir;

public:
  explicit Fs_directory(PagingAccessor *accessor, fs_object_t obj,
                        ext2_filsys fs, ext2_ino_t dir)
  : MappedFileResource(accessor, obj), _fs(fs), _dir(dir)
  {
  }
};
